diff --git a/src/smallmap_gui.cpp b/src/smallmap_gui.cpp
--- a/src/smallmap_gui.cpp
+++ b/src/smallmap_gui.cpp
@@ -1121,43 +3130,91 @@
 	{
 		uint min_width = 0;
 		this->min_number_of_columns = INDUSTRY_MIN_NUMBER_OF_COLUMNS;
-		this->min_number_of_fixed_rows = 0;
-		for (uint i = 0; i < lengthof(_legend_table); i++) {
-			uint height = 0;
-			uint num_columns = 1;
-			for (const LegendAndColour *tbl = _legend_table[i]; !tbl->end; ++tbl) {
-				StringID str;
-				if (i == SMT_INDUSTRY) {
-					SetDParam(0, tbl->legend);
-					SetDParam(1, IndustryPool::MAX_SIZE);
-					str = STR_SMALLMAP_INDUSTRY;
-				} else if (i == SMT_OWNER) {
-					if (tbl->company != INVALID_COMPANY) {
-						if (!Company::IsValidID(tbl->company)) {
-							/* Rebuild the owner legend. */
-							BuildOwnerLegend();
-							this->OnInit();
-							return;
+//		this->min_number_of_fixed_rows = 0;
+		this->min_number_of_fixed_rows = lengthof(_legend_linkstats) / 2 + 1;
+		if (AllowMoreHeightlevels()) {
+			for (uint i = 0; i < lengthof(_legend_table_extended); i++) {
+				uint height = 0;
+				uint num_columns = 1;
+				for (const LegendAndColour *tbl = _legend_table_extended[i]; !tbl->end; ++tbl) {
+					StringID str;
+					if (i == SMT_INDUSTRY) {
+						SetDParam(0, tbl->legend);
+						SetDParam(1, IndustryPool::MAX_SIZE);
+						str = STR_SMALLMAP_INDUSTRY;
+					} else if (i == SMT_LINKSTATS) {
+						SetDParam(0, tbl->legend);
+						str = STR_SMALLMAP_LINKSTATS;
+					} else if (i == SMT_OWNER) {
+						if (tbl->company != INVALID_COMPANY) {
+							if (!Company::IsValidID(tbl->company)) {
+								/* Rebuild the owner legend. */
+								BuildOwnerLegend();
+								this->OnInit();
+								return;
+							}
+							/* Non-fixed legend entries for the owner view. */
+							SetDParam(0, tbl->company);
+							str = STR_SMALLMAP_COMPANY;
+						} else {
+							str = tbl->legend;
+	 					}
+					} else {
+						if (tbl->col_break) {
+							this->min_number_of_fixed_rows = max(this->min_number_of_fixed_rows, height);
+							height = 0;
+							num_columns++;
 						}
-						/* Non-fixed legend entries for the owner view. */
-						SetDParam(0, tbl->company);
-						str = STR_SMALLMAP_COMPANY;
-					} else {
+						height++;
 						str = tbl->legend;
 					}
-				} else {
-					if (tbl->col_break) {
-						this->min_number_of_fixed_rows = max(this->min_number_of_fixed_rows, height);
-						height = 0;
-						num_columns++;
+					min_width = max(GetStringBoundingBox(str).width, min_width);
+				}
+				this->min_number_of_fixed_rows = max(this->min_number_of_fixed_rows, height);
+				this->min_number_of_columns = max(this->min_number_of_columns, num_columns);
+			}
+
+		} else {
+			for (uint i = 0; i < lengthof(_legend_table_old); i++) {
+				uint height = 0;
+				uint num_columns = 1;
+				for (const LegendAndColour *tbl = _legend_table_old[i]; !tbl->end; ++tbl) {
+					StringID str;
+					if (i == SMT_INDUSTRY) {
+						SetDParam(0, tbl->legend);
+						SetDParam(1, IndustryPool::MAX_SIZE);
+						str = STR_SMALLMAP_INDUSTRY;
+					} else if (i == SMT_LINKSTATS) {
+						SetDParam(0, tbl->legend);
+						str = STR_SMALLMAP_LINKSTATS;
+					} else if (i == SMT_OWNER) {
+						if (tbl->company != INVALID_COMPANY) {
+							if (!Company::IsValidID(tbl->company)) {
+								/* Rebuild the owner legend. */
+								BuildOwnerLegend();
+								this->OnInit();
+								return;
+							}
+							/* Non-fixed legend entries for the owner view. */
+							SetDParam(0, tbl->company);
+							str = STR_SMALLMAP_COMPANY;
+						} else {
+							str = tbl->legend;
+	 					}
+					} else {
+						if (tbl->col_break) {
+							this->min_number_of_fixed_rows = max(this->min_number_of_fixed_rows, height);
+							height = 0;
+							num_columns++;
+						}
+						height++;
+						str = tbl->legend;
 					}
-					height++;
-					str = tbl->legend;
+					min_width = max(GetStringBoundingBox(str).width, min_width);
 				}
-				min_width = max(GetStringBoundingBox(str).width, min_width);
+				this->min_number_of_fixed_rows = max(this->min_number_of_fixed_rows, height);
+				this->min_number_of_columns = max(this->min_number_of_columns, num_columns);
 			}
-			this->min_number_of_fixed_rows = max(this->min_number_of_fixed_rows, height);
-			this->min_number_of_columns = max(this->min_number_of_columns, num_columns);
 		}
 
 		/* The width of a column is the minimum width of all texts + the size of the blob + some spacing */
@@ -1167,12 +3224,23 @@
 	virtual void OnPaint()
 	{
 		if (this->map_type == SMT_OWNER) {
-			for (const LegendAndColour *tbl = _legend_table[this->map_type]; !tbl->end; ++tbl) {
-				if (tbl->company != INVALID_COMPANY && !Company::IsValidID(tbl->company)) {
-					/* Rebuild the owner legend. */
-					BuildOwnerLegend();
-					this->InvalidateData(1);
-					break;
+			if (AllowMoreHeightlevels()) {
+				for (const LegendAndColour *tbl = _legend_table_extended[this->map_type]; !tbl->end; ++tbl) {
+					if (tbl->company != INVALID_COMPANY && !Company::IsValidID(tbl->company)) {
+						/* Rebuild the owner legend. */
+						BuildOwnerLegend();
+						this->InvalidateData(1);
+						break;
+					}
+				}
+			} else {
+				for (const LegendAndColour *tbl = _legend_table_old[this->map_type]; !tbl->end; ++tbl) {
+					if (tbl->company != INVALID_COMPANY && !Company::IsValidID(tbl->company)) {
+						/* Rebuild the owner legend. */
+						BuildOwnerLegend();
+						this->InvalidateData(1);
+						break;
+					}
 				}
 			}
 		}
@@ -1191,64 +3259,180 @@
 			}
 
 			case SM_WIDGET_LEGEND: {
-				uint columns = this->GetNumberColumnsLegend(r.right - r.left + 1);
-				uint number_of_rows = max((this->map_type == SMT_INDUSTRY || this->map_type == SMT_OWNER) ? CeilDiv(max(_smallmap_company_count, _smallmap_industry_count), columns) : 0, this->min_number_of_fixed_rows);
-				bool rtl = _current_text_dir == TD_RTL;
 				uint y_org = r.top + WD_FRAMERECT_TOP;
-				uint x = rtl ? r.right - this->column_width - WD_FRAMERECT_RIGHT : r.left + WD_FRAMERECT_LEFT;
-				uint y = y_org;
-				uint i = 0; // Row counter for industry legend.
-				uint row_height = FONT_HEIGHT_SMALL;
-
-				uint text_left  = rtl ? 0 : LEGEND_BLOB_WIDTH + WD_FRAMERECT_LEFT;
-				uint text_right = this->column_width - 1 - (rtl ? LEGEND_BLOB_WIDTH + WD_FRAMERECT_RIGHT : 0);
-				uint blob_left  = rtl ? this->column_width - 1 - LEGEND_BLOB_WIDTH : 0;
-				uint blob_right = rtl ? this->column_width - 1 : LEGEND_BLOB_WIDTH;
-
-				for (const LegendAndColour *tbl = _legend_table[this->map_type]; !tbl->end; ++tbl) {
-					if (tbl->col_break || ((this->map_type == SMT_INDUSTRY || this->map_type == SMT_OWNER) && i++ >= number_of_rows)) {
-						/* Column break needed, continue at top, COLUMN_WIDTH pixels
-						 * (one "row") to the right. */
-						x += rtl ? -(int)this->column_width : this->column_width;
-						y = y_org;
-						i = 1;
+				uint x = r.left + WD_FRAMERECT_LEFT;
+				if (this->supply_details != INVALID_STATION) {
+					this->DrawSupplyDetails(x, y_org, r.bottom - WD_FRAMERECT_BOTTOM);
+				} else if (!this->link_details.Empty()) {
+					this->DrawLinkDetails(x, y_org, r.right - WD_FRAMERECT_RIGHT, r.bottom - WD_FRAMERECT_BOTTOM);
+				} else {
+					uint columns = this->GetNumberColumnsLegend(r.right - r.left + 1);
+					uint number_of_rows = this->GetNumberRowsLegend(columns);
+					bool rtl = _current_text_dir == TD_RTL;
+					uint y_org = r.top + WD_FRAMERECT_TOP;
+					uint x = rtl ? r.right - this->column_width - WD_FRAMERECT_RIGHT : r.left + WD_FRAMERECT_LEFT;
+					uint y = y_org;
+					uint i = 0; // Row counter for industry legend.
+					uint row_height = FONT_HEIGHT_SMALL;
+
+					uint text_left  = rtl ? 0 : LEGEND_BLOB_WIDTH + WD_FRAMERECT_LEFT;
+					uint text_right = this->column_width - 1 - (rtl ? LEGEND_BLOB_WIDTH + WD_FRAMERECT_RIGHT : 0);
+					uint blob_left  = rtl ? this->column_width - 1 - LEGEND_BLOB_WIDTH : 0;
+					uint blob_right = rtl ? this->column_width - 1 : LEGEND_BLOB_WIDTH;
+
+					StringID string = STR_NULL;
+					switch (this->map_type) {
+						case SMT_INDUSTRY:
+							string = STR_SMALLMAP_INDUSTRY;
+							break;
+						case SMT_LINKSTATS:
+							string = STR_SMALLMAP_LINKSTATS;
+							break;
+						case SMT_OWNER:
+							string = STR_SMALLMAP_COMPANY;
+							break;
+						default:
+							break;
 					}
 
-					if (this->map_type == SMT_INDUSTRY) {
-						/* Industry name must be formatted, since it's not in tiny font in the specs.
-						 * So, draw with a parameter and use the STR_SMALLMAP_INDUSTRY string, which is tiny font */
-						SetDParam(0, tbl->legend);
-						SetDParam(1, Industry::GetIndustryTypeCount(tbl->type));
-						if (!tbl->show_on_map) {
-							/* Simply draw the string, not the black border of the legend colour.
-							 * This will enforce the idea of the disabled item */
-							DrawString(x + text_left, x + text_right, y, STR_SMALLMAP_INDUSTRY, TC_GREY);
-						} else {
-							DrawString(x + text_left, x + text_right, y, STR_SMALLMAP_INDUSTRY, TC_BLACK);
-							GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK); // Outer border of the legend colour
-						}
-					} else if (this->map_type == SMT_OWNER && tbl->company != INVALID_COMPANY) {
-						SetDParam(0, tbl->company);
-						if (!tbl->show_on_map) {
-							/* Simply draw the string, not the black border of the legend colour.
-							 * This will enforce the idea of the disabled item */
-							DrawString(x + text_left, x + text_right, y, STR_SMALLMAP_COMPANY, TC_GREY);
-						} else {
-							DrawString(x + text_left, x + text_right, y, STR_SMALLMAP_COMPANY, TC_BLACK);
-							GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK); // Outer border of the legend colour
+					if (AllowMoreHeightlevels()) {
+						for (const LegendAndColour *tbl = _legend_table_extended[this->map_type]; !tbl->end; ++tbl) {
+							if (tbl->col_break || ((this->map_type == SMT_INDUSTRY || this->map_type == SMT_LINKSTATS || this->map_type == SMT_OWNER) && i++ >= number_of_rows)) {
+								/* Column break needed, continue at top, COLUMN_WIDTH pixels
+								 * (one "row") to the right. */
+								x += rtl ? -(int)this->column_width : this->column_width;
+								y = y_org;
+								i = 1;
+							}
+
+							switch(this->map_type) {
+								case SMT_INDUSTRY:
+									/* Industry name must be formatted, since it's not in tiny font in the specs.
+									 * So, draw with a parameter and use the STR_SMALLMAP_INDUSTRY string, which is tiny font. */
+									SetDParam(1, Industry::GetIndustryTypeCount(tbl->type));
+								case SMT_LINKSTATS:
+									SetDParam(0, tbl->legend);
+								case SMT_OWNER:
+									if (this->map_type != SMT_OWNER || tbl->company != INVALID_COMPANY) {
+										if (this->map_type == SMT_OWNER) SetDParam(0, tbl->company);
+										if (!tbl->show_on_map) {
+											/* Simply draw the string, not the black border of the legend colour.
+											* This will enforce the idea of the disabled item */
+											DrawString(x + text_left, x + text_right, y, string, TC_GREY);
+										} else {
+											DrawString(x + text_left, x + text_right, y, string, TC_BLACK);
+											GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK); // Outer border of the legend colour
+										}
+									break;
+									} // else fall through
+								default:
+									if (this->map_type == SMT_CONTOUR) SetDParam(0, tbl->height * TILE_HEIGHT_STEP);
+
+									/* Anything that is not an industry or a company is using normal process */
+									GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK);
+									DrawString(x + text_left, x + text_right, y, tbl->legend);
+									break;
+							}
+							GfxFillRect(x + blob_left + 1, y + 2, x + blob_right - 1, y + row_height - 2, tbl->colour); // Legend colour.
+
+							y += row_height;
 						}
 					} else {
-						if (this->map_type == SMT_CONTOUR) SetDParam(0, tbl->height * TILE_HEIGHT_STEP);
-
-						/* Anything that is not an industry or a company is using normal process */
-						GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK);
-						DrawString(x + text_left, x + text_right, y, tbl->legend);
+						for (const LegendAndColour *tbl = _legend_table_old[this->map_type]; !tbl->end; ++tbl) {
+							if (tbl->col_break || ((this->map_type == SMT_INDUSTRY || this->map_type == SMT_LINKSTATS || this->map_type == SMT_OWNER) && i++ >= number_of_rows)) {
+								/* Column break needed, continue at top, COLUMN_WIDTH pixels
+								 * (one "row") to the right. */
+								x += rtl ? -(int)this->column_width : this->column_width;
+								y = y_org;
+								i = 1;
+							}
+
+							switch(this->map_type) {
+								case SMT_INDUSTRY:
+									/* Industry name must be formatted, since it's not in tiny font in the specs.
+									 * So, draw with a parameter and use the STR_SMALLMAP_INDUSTRY string, which is tiny font. */
+									SetDParam(1, Industry::GetIndustryTypeCount(tbl->type));
+								case SMT_LINKSTATS:
+									SetDParam(0, tbl->legend);
+								case SMT_OWNER:
+									if (this->map_type != SMT_OWNER || tbl->company != INVALID_COMPANY) {
+										if (this->map_type == SMT_OWNER) SetDParam(0, tbl->company);
+										if (!tbl->show_on_map) {
+											/* Simply draw the string, not the black border of the legend colour.
+											* This will enforce the idea of the disabled item */
+											DrawString(x + text_left, x + text_right, y, string, TC_GREY);
+										} else {
+											DrawString(x + text_left, x + text_right, y, string, TC_BLACK);
+											GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK); // Outer border of the legend colour
+										}
+									break;
+									} // else fall through
+								default:
+									if (this->map_type == SMT_CONTOUR) SetDParam(0, tbl->height * TILE_HEIGHT_STEP);
+
+									/* Anything that is not an industry or a company is using normal process */
+									GfxFillRect(x + blob_left, y + 1, x + blob_right, y + row_height - 1, PC_BLACK);
+									DrawString(x + text_left, x + text_right, y, tbl->legend);
+									break;
+							}
+							GfxFillRect(x + blob_left + 1, y + 2, x + blob_right - 1, y + row_height - 2, tbl->colour); // Legend colour
+
+							y += row_height;
+						}
 					}
-					GfxFillRect(x + blob_left + 1, y + 2, x + blob_right - 1, y + row_height - 2, tbl->colour); // Legend colour
-
-					y += row_height;
+				}
+			} break;
+		}
+	}
+
+	/**
+	 * Get the number of rows in the legend from the number of columns. Those
+	 * are at least min_number_of_fixed_rows and possibly more if there are so
+	 * many cargoes, industry types or companies that they won't fit in the
+	 * available space.
+	 * @param columns Number of columns in the legend.
+	 * @return Number of rows needed for everything to fit in.
+	 */
+	uint GetNumberRowsLegend(uint columns) const
+	{
+		/* reserve one column for link colours */
+		uint num_rows_linkstats = CeilDiv(_smallmap_cargo_count, columns - 1);
+
+		uint num_rows_others = CeilDiv(max(_smallmap_industry_count,_smallmap_company_count), columns);
+		return max(this->min_number_of_fixed_rows, max(num_rows_linkstats, num_rows_others));
+	}
+
+	/**
+	 * Select and toggle a legend item. When CTRL is pressed, disable all other
+	 * items in the group defined by begin_legend_item and end_legend_item and
+	 * keep the clicked one enabled even if it was already enabled before. If
+	 * the other items in the group are all disabled already and CTRL is pressed
+	 * enable them instead.
+	 * @param click_pos the index of the item being selected
+	 * @param legend the legend from which we select
+	 * @param end_legend_item index one past the last item in the group to be inverted
+	 * @param begin_legend_item index of the first item in the group to be inverted
+	 */
+	void SelectLegendItem(int click_pos, LegendAndColour *legend, int end_legend_item, int begin_legend_item = 0)
+	{
+		if (_ctrl_pressed) {
+			/* Disable all, except the clicked one */
+			bool changes = false;
+			for (int i = begin_legend_item; i != end_legend_item; i++) {
+				bool new_state = (i == click_pos);
+				if (legend[i].show_on_map != new_state) {
+					changes = true;
+					legend[i].show_on_map = new_state;
 				}
 			}
+			if (!changes) {
+				/* Nothing changed? Then show all (again). */
+				for (int i = begin_legend_item; i != end_legend_item; i++) {
+					legend[i].show_on_map = true;
+				}
+			}
+		} else {
+			legend[click_pos].show_on_map = !legend[click_pos].show_on_map;
 		}
 	}
 
@@ -1285,15 +3469,40 @@
 				_left_button_clicked = false;
 
 				const NWidgetBase *wid = this->GetWidget<NWidgetBase>(SM_WIDGET_MAP);
+
+				/* We need to take the height at the clicked position into account
+				 * (i.e. move the map northwards).
+				 * Basically, we compute the inverse of function RemapX/Y here.
+				 * Note that we have to subtract 2 from x and 16 from y here because
+				 * _cursor_pos.x/y - this->left/top includes the edge of the small map. */
+				int offset_inside_sm_x = _cursor.pos.x - this->left + wid->pos_x;
+				int offset_inside_sm_y = _cursor.pos.y - this->top - wid->pos_y;
+				int clicked_screen_x = offset_inside_sm_x * TILE_SIZE + pt.x;
+				int clicked_screen_y = offset_inside_sm_y * TILE_SIZE + pt.y;
+				Point clicked_tile = TileCoordFromScreenCoord(clicked_screen_x, clicked_screen_y);
+				clicked_tile.x /= TILE_SIZE;
+				clicked_tile.y /= TILE_SIZE;
+				int clicked_tile_height = TileHeightOutsideMap(clicked_tile.x, clicked_tile.y);
+
+				DEBUG(map, 9, "clicked: offset_inside_sm (%i,%i), clicked_tile (%i,%i), clicked_screen (%i,%i), clicked_tile_height %i",
+						offset_inside_sm_x, offset_inside_sm_y, clicked_tile.x, clicked_tile.y, clicked_screen_x, clicked_screen_y, clicked_tile_height);
+
 				Window *w = FindWindowById(WC_MAIN_WINDOW, 0);
 				int sub;
-				pt = this->PixelToTile(pt.x - wid->pos_x, pt.y - wid->pos_y, &sub);
-				pt = RemapCoords(this->scroll_x + pt.x * TILE_SIZE + this->zoom * (TILE_SIZE - sub * TILE_SIZE / 4),
-						this->scroll_y + pt.y * TILE_SIZE + sub * this->zoom * TILE_SIZE / 4, 0);
+				pt = this->PixelToWorld(pt.x - wid->pos_x, pt.y - wid->pos_y, &sub);
+				int offset = this->zoom > 0 ? this->zoom * TILE_SIZE : TILE_SIZE / (-this->zoom);
+				pt = RemapCoords(this->scroll_x + pt.x + offset - offset * sub / 4,
+						this->scroll_y + pt.y + sub * offset / 4, 0);
 
 				w->viewport->follow_vehicle = INVALID_VEHICLE;
 				w->viewport->dest_scrollpos_x = pt.x - (w->viewport->virtual_width  >> 1);
-				w->viewport->dest_scrollpos_y = pt.y - (w->viewport->virtual_height >> 1);
+				w->viewport->dest_scrollpos_y = pt.y - ((clicked_tile_height * TILE_HEIGHT) + (w->viewport->virtual_height >> 1)); // TODO: add moreheightlevels_v29 and merge with cargodist (when clicking the smallmap main vieport positioning is slighlty off)
+
+				DEBUG(map, 9, "OnClick: scroll_x, scroll_y = (%i,%i), pt = (%i,%i), dest_scrollpos = (%i,%i), cursor = (%i,%i), left/top = (%i, %i), virtual = (%i,%i)",
+						this->scroll_x, this->scroll_y, pt.x, pt.y,
+						w->viewport->dest_scrollpos_x, w->viewport->dest_scrollpos_y,
+						_cursor.pos.x, _cursor.pos.y, this->left, this->top,
+						w->viewport->virtual_width, w->viewport->virtual_height);
 
 				this->SetDirty();
 				break;
@@ -1311,6 +3520,7 @@
 			case SM_WIDGET_CONTOUR:    // Show land contours
 			case SM_WIDGET_VEHICLES:   // Show vehicles
 			case SM_WIDGET_INDUSTRIES: // Show industries
+			case SM_WIDGET_LINKSTATS:  // Show route map
 			case SM_WIDGET_ROUTES:     // Show transport routes
 			case SM_WIDGET_VEGETATION: // Show vegetation
 			case SM_WIDGET_OWNERS:     // Show land owners
@@ -1333,98 +3543,68 @@
 				break;
 
 			case SM_WIDGET_LEGEND: // Legend
-				if (this->map_type == SMT_INDUSTRY || this->map_type == SMT_OWNER) {
+				/* If industry type small map*/
+				if (this->map_type == SMT_INDUSTRY || this->map_type == SMT_LINKSTATS || this->map_type == SMT_OWNER) {
+					/* If click on industries label, find right industry type and enable/disable it */
 					const NWidgetBase *wi = this->GetWidget<NWidgetBase>(SM_WIDGET_LEGEND); // Label panel
 					uint line = (pt.y - wi->pos_y - WD_FRAMERECT_TOP) / FONT_HEIGHT_SMALL;
 					uint columns = this->GetNumberColumnsLegend(wi->current_x);
-					uint number_of_rows = max(CeilDiv(max(_smallmap_company_count, _smallmap_industry_count), columns), this->min_number_of_fixed_rows);
+					uint number_of_rows = this->GetNumberRowsLegend(columns);
 					if (line >= number_of_rows) break;
 
 					bool rtl = _current_text_dir == TD_RTL;
 					int x = pt.x - wi->pos_x;
 					if (rtl) x = wi->current_x - x;
 					uint column = (x - WD_FRAMERECT_LEFT) / this->column_width;
-
-					/* If industry type small map*/
+					int click_pos = (column * number_of_rows) + line;
+
+					/* Check if click is on industry label*/
 					if (this->map_type == SMT_INDUSTRY) {
-						/* If click on industries label, find right industry type and enable/disable it. */
-						int industry_pos = (column * number_of_rows) + line;
-						if (industry_pos < _smallmap_industry_count) {
-							if (_ctrl_pressed) {
-								/* Disable all, except the clicked one. */
-								bool changes = false;
-								for (int i = 0; i != _smallmap_industry_count; i++) {
-									bool new_state = i == industry_pos;
-									if (_legend_from_industries[i].show_on_map != new_state) {
-										changes = true;
-										_legend_from_industries[i].show_on_map = new_state;
-									}
-								}
-								if (!changes) {
-									/* Nothing changed? Then show all (again). */
-									for (int i = 0; i != _smallmap_industry_count; i++) {
-										_legend_from_industries[i].show_on_map = true;
-									}
-								}
-							} else {
-								_legend_from_industries[industry_pos].show_on_map = !_legend_from_industries[industry_pos].show_on_map;
+						if (click_pos < _smallmap_industry_count) {
+							this->SelectLegendItem(click_pos, _legend_from_industries, _smallmap_industry_count);
+						}
+					/* Check if click was on linkstats label*/
+					} else if (this->map_type == SMT_LINKSTATS) {
+						if (click_pos < _smallmap_cargo_count) {
+							this->SelectLegendItem(click_pos, _legend_linkstats, _smallmap_cargo_count);
+						} else {
+							uint stats_column = CeilDiv(_smallmap_cargo_count, number_of_rows);
+							if (column == stats_column && line < NUM_STATS) {
+								this->SelectLegendItem(_smallmap_cargo_count + line, _legend_linkstats,
+										_smallmap_cargo_count + NUM_STATS, _smallmap_cargo_count);
 							}
 						}
+					/* Check if click is on company label. */
 					} else if (this->map_type == SMT_OWNER) {
-						/* If click on companies label, find right company and enable/disable it. */
-						int company_pos = (column * number_of_rows) + line;
-						if (company_pos < NUM_NO_COMPANY_ENTRIES) break;
-						if (company_pos < _smallmap_company_count) {
-							if (_ctrl_pressed) {
-								/* Disable all, except the clicked one */
-								bool changes = false;
-								for (int i = NUM_NO_COMPANY_ENTRIES; i != _smallmap_company_count; i++) {
-									bool new_state = i == company_pos;
-									if (_legend_land_owners[i].show_on_map != new_state) {
-										changes = true;
-										_legend_land_owners[i].show_on_map = new_state;
-									}
-								}
-								if (!changes) {
-									/* Nothing changed? Then show all (again). */
-									for (int i = NUM_NO_COMPANY_ENTRIES; i != _smallmap_company_count; i++) {
-										_legend_land_owners[i].show_on_map = true;
-									}
-								}
-							} else {
-								_legend_land_owners[company_pos].show_on_map = !_legend_land_owners[company_pos].show_on_map;
-							}
+						if (click_pos < _smallmap_company_count) {
+						this->SelectLegendItem(click_pos, _legend_land_owners, _smallmap_company_count, NUM_NO_COMPANY_ENTRIES);
 						}
 					}
 					this->SetDirty();
 				}
 				break;
 
-			case SM_WIDGET_ENABLE_ALL:
-				if (this->map_type == SMT_INDUSTRY) {
-					for (int i = 0; i != _smallmap_industry_count; i++) {
-						_legend_from_industries[i].show_on_map = true;
+			case SM_WIDGET_ENABLE_ALL: // enable/diable all items
+			case SM_WIDGET_DISABLE_ALL: {
+				LegendAndColour *tbl = NULL;
+					switch (this->map_type) {
+						case SMT_INDUSTRY:
+							tbl = _legend_from_industries;
+							break;
+						case SMT_OWNER:
+							tbl = &(_legend_land_owners[NUM_NO_COMPANY_ENTRIES]);
+							break;
+						case SMT_LINKSTATS:
+							tbl = _legend_linkstats;
+							break;
+						default:
+							NOT_REACHED();
 					}
-				} else if (this->map_type == SMT_OWNER) {
-					for (int i = NUM_NO_COMPANY_ENTRIES; i != _smallmap_company_count; i++) {
-						_legend_land_owners[i].show_on_map = true;
-					}
-				}
+
+				for (;!tbl->end; ++tbl) tbl->show_on_map = (widget == SM_WIDGET_ENABLE_ALL);
 				this->SetDirty();
 				break;
-
-			case SM_WIDGET_DISABLE_ALL:
-				if (this->map_type == SMT_INDUSTRY) {
-					for (int i = 0; i != _smallmap_industry_count; i++) {
-						_legend_from_industries[i].show_on_map = false;
-					}
-				} else {
-					for (int i = NUM_NO_COMPANY_ENTRIES; i != _smallmap_company_count; i++) {
-						_legend_land_owners[i].show_on_map = false;
-					}
-				}
-				this->SetDirty();
-				break;
+			}
 
 			case SM_WIDGET_SHOW_HEIGHT: // Enable/disable showing of heightmap.
 				_smallmap_show_heightmap = !_smallmap_show_heightmap;
@@ -1434,6 +3614,22 @@
 		}
 	}
 
+	virtual void OnMouseOver(Point pt, int widget)
+	{
+		static Point invalid = {-1, -1};
+		if (widget == SM_WIDGET_MAP) {
+			const NWidgetBase *wid = this->GetWidget<NWidgetBase>(SM_WIDGET_MAP);
+			pt.x -= wid->pos_x;
+			pt.y -= wid->pos_y;
+			if (pt.x != cursor.x || pt.y != cursor.y) {
+				this->refresh = 1;
+				cursor = pt;
+			}
+		} else {
+			cursor = invalid;
+		}
+	}
+
 	/**
 	 * Some data on this window has become invalid.
 	 * @param data Information about the changed data.
@@ -1491,6 +3687,8 @@
 		/* Update the window every now and then */
 		if (--this->refresh != 0) return;
 
+		this->RecalcVehiclePositions();
+
 		this->refresh = FORCE_REFRESH_PERIOD;
 		this->SetDirty();
 	}
@@ -1506,8 +3704,13 @@
 	{
 		const NWidgetBase *wi = this->GetWidget<NWidgetBase>(SM_WIDGET_MAP);
 		Point hv = InverseRemapCoords(wi->current_x * TILE_SIZE / 2, wi->current_y * TILE_SIZE / 2);
-		hv.x *= this->zoom;
-		hv.y *= this->zoom;
+		if (this->zoom > 0) {
+			hv.x *= this->zoom;
+			hv.y *= this->zoom;
+		} else {
+			hv.x /= (-this->zoom);
+			hv.y /= (-this->zoom);
+		}
 
 		if (sx < -hv.x) {
 			sx = -hv.x;
@@ -1537,8 +3740,8 @@
 
 		/* While tile is at (delta.x, delta.y)? */
 		int sub;
-		Point pt = this->PixelToTile(delta.x, delta.y, &sub);
-		this->SetNewScroll(this->scroll_x + pt.x * TILE_SIZE, this->scroll_y + pt.y * TILE_SIZE, sub);
+		Point pt = this->PixelToWorld(delta.x, delta.y, &sub);
+		this->SetNewScroll(this->scroll_x + pt.x, this->scroll_y + pt.y, sub);
 
 		this->SetDirty();
 	}
@@ -1550,10 +3753,12 @@
 
 		int sub;
 		const NWidgetBase *wid = this->GetWidget<NWidgetBase>(SM_WIDGET_MAP);
-		Point sxy = this->ComputeScroll(pt.x / TILE_SIZE, pt.y / TILE_SIZE, max(0, (int)wid->current_x / 2 - 2), wid->current_y / 2, &sub);
+		Point sxy = this->ComputeScroll(pt.x, pt.y, max(0, (int)wid->current_x / 2 - 2), wid->current_y / 2, &sub);
 		this->SetNewScroll(sxy.x, sxy.y, sub);
 		this->SetDirty();
 	}
+
+	uint ColumnWidth() const {return column_width;}
 };
 
 SmallMapWindow::SmallMapType SmallMapWindow::map_type = SMT_CONTOUR;
@@ -1586,6 +3791,7 @@
 		this->smallmap_window = dynamic_cast<SmallMapWindow *>(w);
 		this->smallest_x = max(display->smallest_x, bar->smallest_x + smallmap_window->GetMinLegendWidth());
 		this->smallest_y = display->smallest_y + max(bar->smallest_y, smallmap_window->GetLegendHeight(smallmap_window->min_number_of_columns));
+//		this->smallest_y = display->smallest_y + max(bar->smallest_y, smallmap_window->GetLegendHeight());
 		this->fill_x = max(display->fill_x, bar->fill_x);
 		this->fill_y = (display->fill_y == 0 && bar->fill_y == 0) ? 0 : min(display->fill_y, bar->fill_y);
 		this->resize_x = max(display->resize_x, bar->resize_x);
@@ -1610,7 +3816,8 @@
 			bar->AssignSizePosition(ST_SMALLEST, x, y + display->smallest_y, bar->smallest_x, bar->smallest_y, rtl);
 		}
 
-		uint bar_height = max(bar->smallest_y, this->smallmap_window->GetLegendHeight(this->smallmap_window->GetNumberColumnsLegend(given_width - bar->smallest_x)));
+//		uint bar_height = max(bar->smallest_y, this->smallmap_window->GetLegendHeight(this->smallmap_window->GetNumberColumnsLegend(given_width - bar->smallest_x)));
+		uint bar_height = max(bar->smallest_y, this->smallmap_window->GetLegendHeight(given_width - bar->smallest_x));
 		uint display_height = given_height - bar_height;
 		display->AssignSizePosition(ST_RESIZE, x, y, given_width, display_height, rtl);
 		bar->AssignSizePosition(ST_RESIZE, x, y + display_height, given_width, bar_height, rtl);
@@ -1651,6 +3858,8 @@
 							SetDataTip(SPR_IMG_ZOOMIN, STR_TOOLBAR_TOOLTIP_ZOOM_THE_VIEW_IN), SetFill(1, 1),
 					NWidget(WWT_PUSHIMGBTN, COLOUR_BROWN, SM_WIDGET_CENTERMAP),
 							SetDataTip(SPR_IMG_SMALLMAP, STR_SMALLMAP_CENTER), SetFill(1, 1),
+					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_BLANK), SetMinimalSize(22, 22),
+							SetDataTip(SPR_DOT_SMALL, STR_NULL), SetFill(1, 1),
 					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_CONTOUR),
 							SetDataTip(SPR_IMG_SHOW_COUNTOURS, STR_SMALLMAP_TOOLTIP_SHOW_LAND_CONTOURS_ON_MAP), SetFill(1, 1),
 					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_VEHICLES),
@@ -1664,6 +3873,8 @@
 							SetDataTip(SPR_IMG_ZOOMOUT, STR_TOOLBAR_TOOLTIP_ZOOM_THE_VIEW_OUT), SetFill(1, 1),
 					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_TOGGLETOWNNAME),
 							SetDataTip(SPR_IMG_TOWN, STR_SMALLMAP_TOOLTIP_TOGGLE_TOWN_NAMES_ON_OFF), SetFill(1, 1),
+					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_LINKSTATS),
+							SetDataTip(SPR_IMG_GRAPHS, STR_SMALLMAP_TOOLTIP_SHOW_LINK_STATS_ON_MAP), SetFill(1, 1),
 					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_ROUTES),
 							SetDataTip(SPR_IMG_SHOW_ROUTES, STR_SMALLMAP_TOOLTIP_SHOW_TRANSPORT_ROUTES_ON), SetFill(1, 1),
 					NWidget(WWT_IMGBTN, COLOUR_BROWN, SM_WIDGET_VEGETATION),
@@ -1715,7 +3926,7 @@
 };
 
 static const WindowDesc _smallmap_desc(
-	WDP_AUTO, 446, 314,
+	WDP_AUTO, 484, 314,
 	WC_SMALLMAP, WC_NONE,
 	WDF_UNCLICK_BUTTONS,
 	_nested_smallmap_widgets, lengthof(_nested_smallmap_widgets)
diff --git a/src/smallmap_gui.h b/src/smallmap_gui.h
--- a/src/smallmap_gui.h
+++ b/src/smallmap_gui.h
@@ -12,6 +12,9 @@
 #ifndef SMALLMAP_GUI_H
 #define SMALLMAP_GUI_H
 
+/* set up the cargos to be displayed in the smallmap's route legend */
+void BuildLinkStatsLegend();
+
 void BuildIndustriesLegend();
 void ShowSmallMap();
 void BuildLandLegend();
